// from: http://www.ifadey.com/2011/07/context-menu-using-raw-javascript/

/* context menu */
translations["Zoom Here"] = {"Czech": "Přiblížit mapu"};
translations["Center Map Here"] = {"Czech": "Střed mapy"};
translations["Show All"] = {"Czech": "Zobrazit VŠECHNY Waypointy"};
translations["Add Child Here"] = {"Czech": "Zde vytvořit Child Waypoint"};
translations["Add Waypoint Here"] = {"Czech": "Zde vytvořit Waypoint"};
translations["Coordinates to Clipboard"] = {"Czech": "Uložit souřadnice do schránky"};
translations["Set GSAK Center Point"] = {"Czech": "Nastavit jako Referenční bod v GSAKu"};
translations["Project point..."] = {"Czech": "Projekce bodu..."};
translations["Draw a circle..."] = {"Czech": "Nakresli kruh..."};
translations["Run Map Macro"] = {"Czech": "Spustit makro pro Google mapy"};
translations["Land Registry (CZ)"] = {"Czech": "Katastr"};
translations["_open_photo_page"] = {"Czech": "Geolocation.ws", "English": "Geolocation.ws"},
translations["Find: "] = {"Czech": "Hledat: "};
translations["Nothing found!"] = {"Czech": "Nic nenalezeno!"};

/* context menu for waypoints */
translations["Save New Coordinates"] = {"Czech": "Uložit nové souřadnice"};
translations["Flag (Parent)"] = {"Czech": "Označit (rodič)"};
translations["Remove Flag (Parent)"] = {"Czech": "Zrušit označení (rodič)"};
translations["Flag (Child)"] = {"Czech": "Označit (dítě)"};
translations["Remove Flag (Child)"] = {"Czech": "Zrušit označení (dítě)"};
translations["Delete (Parent)"] = {"Czech": "Smazat (rodič)"};
translations["Delete (Child)"] = {"Czech": "Smazat (dítě)"};
translations["Remove from Map"] = {"Czech": "Smazat z mapy"};
translations["Open Waypoint Page"] = {"Czech": "Otevřít stránku bodu"};
translations["Open Cache Page"] = {"Czech": "Otevřít stránku cache"};
translations["Open Waymark Page"] = {"Czech": "Otevřít stránku waymarku"};
translations["Open in GSAK"] = {"Czech": "Otevřít v GSAKu"};
translations["Open Cache Gallery"] = {"Czech": "Otevřít galerii cache"};
translations["Open Cache Logbook"] = {"Czech": "Otevřít logbook cache"};
translations["Log Cache"] = {"Czech": "Zalogovat cache"};
translations["Log Waymark"] = {"Czech": "Zalogovat waymark"};

translations["wp_drag_ask"] = {"Czech": "Opravdu chcete do databáze uložit nové souřadnice?", "English": "Do you really want to save new coordinates to the database?"};
translations["wp_delete_parent"] = {"Czech": "Opravdu chcete smazat waypoint z databáze?", "English": "Do you really want delete the waypoint from the database?"};
translations["wp_delete_child"] = {"Czech": "Opravdu chcete smazat child waypoint z databáze?", "English": "Do you really want delete the child waypoint from the database?"};

/* help */
translations["Help"] = {"Czech": "Nápověda"};
        
translations["about_box"] = 
{
  "English":
  "Keyboard shorcuts:\n\n" +
  
  (notGSAK ? "" : 
  "During launch (GSAK only):\n" + 
  "CTRL: loads original Google map instead of Mapy.cz map\n" +
  "SHIFT: loads map in the entire lower half of the screen\n" +
  "ALT: reads all caches in the filter\n" +
  "ALT+SHIFT: map in the lower half of the screen + all caches in the filter\n" +
  "\nnote: in versions 8.2.1.76 and newer, GSAK shortcut support is broken, for SHIFT shortcuts working correctly, you need to use mousewheel to move between caches, for CTRL shortcuts working correctly you need to activate a cache using left mouse button!\n" + 

  "\nIn map:\n") +
  "key '`' (above TAB): open the page in a new browser window (in GeoSetter program, SHIFT is needed as well)\n" +
  (notGSAK ? "" : "ENTER: opens small map within listing in the entire window (and vice-versa) - GSAK only\n") +         
  "right drag: alternative and easier method of zooming (in Opera, if you have mouse gestures on, you need to have CTRL pressed during drag)\n" +
  "arrows, plus, minus: move around and zoom in and out\n" +
  "CTRL + Z (CTRL + ALT + Z in Track mode): map position/zoom/type is stored, this returns you one step back\n" +
  "Y: display captions next to all waypoints\n" +
  "SHIFT: same as above, but only while the key is pressed\n" +
  "X: hides all waypoints (if we have mouse over a marker, its entire family will be excluded from hiding)\n" +
  "C: hides all children\n" +
  "P: hides all parents\n" +
  "L: displays lines from parent to all children on hover\n" +
  "R: displays 161m radius around physical waypoints (Traditional, Final Location, Stages of a Multicache)\n" +
  "A: turns on/off waypoint animation\n" +
  "W: opens/hides window with coordinates under cursor\n" +
  "Q: works only when the above is activated (opens copy window)\n" +      
  "Y: turns on/off waypoint animation\n" +            
  "ALT + drag waypoint: move waypoint to new location (+ you can now right click on waypoint and save new coordinates to the database)\n" +
  "drag waypoint: temporarily move waypoint (until mouse up)\n" +
  "right click on waypoint: another menu...\n" +
  "circle drawn using context menu: dragging the center moves it, having pressed CTRL in addition to it changes radius\n" +
  "projected point created using context menu: dragging a point moves it, having CTRL pressed while doing so moves entire structure\n" +
  "... many, many, many more key combinations within the Track menu (which has its own help)\n" +
  "... and there is another help under minimap context menu\n" +
  "\nv" + macro_version + ", " + cur_date + ", by Norbert_G",
  
  "Czech":
  "Klávesové zkratky:\n\n" +
  
  (notGSAK ? "" : 
  "Při spouštění (týká se jen GSAKu):\n" +
  "CTRL: načte listing dle makra, ale s původní Google mapou\n" +
  "SHIFT: zobrazí mapu v celé dolní polovině obrazovky\n" +
  "ALT: vygeneruje do mapy všechny kešky ve filtru\n" +
  "ALT+SHIFT: mapa v dolní polovině obrazovky + vše ve filtru\n" +
  "\npoznámka: od verze 8.2.1.76 je podpora klávesových zkratek v GSAKu rozbitá, pro správnou funkčnost zkratek se SHIFT je nutno přecházet z kešky na kešku kolečkem myši, pro správnou funkčnost zkratek s CTRL je naopak nutno na kešku kliknout!\n" +  
  
  "\nV mapě:\n") +      
  
  "klávesa ';' (nad TAB): otevře stránku v samostatném okně prohlížeče (v GeoSetteru je třeba navíc držet SHIFT)\n" +
  (notGSAK ? "" : "ENTER: otevře malou mapu uvnitř listingu v celém okně (a naopak) - pouze GSAK\n") +          
  "tažení pravým tlačítkem: jednodušší možnost zoomování (v Opeře, pokud máte zapnutá gesta myši, musíte přidržet CTRL)\n" +
  "šipky, plus, mínus: posun mapy a zoomování\n" +
  "CTRL + Z (CTRL + ALT + Z v módu Track): pozice, zoom a typ mapy se ukládájí, toto vás vrátí o krok zpět\n" +
  "Y: zobrazí popisky u všech kešek\n" +
  "SHIFT: to samé, ale jen po dobu stisku klávesy\n" +
  "X: skryje všechny body (pokud je na nějakém ale myš, tak tento bod a jeho rodina zůstanou zobrazeni)\n" +
  "C: skryje všechny děti\n" +
  "P: skryje všechny rodiče\n" +
  "L: zobrazí čáry od rodiče k dětem po najetí na libovolný bod rodiny\n" +
  "R: zobrazí kolizní radius 161 m u fyzických keší (Traditional, Final Location, Stages of a Multicache)\n" +
  "A: vypne animace bodů\n" +
  "W: otevře okno, kde se zobrazují aktuální souřadnice\n" +
  "Q: funguje jen pokud je funkce výše (W) aktivována - otevře kopírovací okénko\n" +            
  "ALT + tažení bodu: posun bodu na nové místo (+ se objeví na pravém tlačítku možnost nové souřadnice uložit do databáze)\n" +
  "tažení bodu: dočasný posun bodu (do puštění myši)\n" +
  "kruh vytvořený pomocí kontextového menu: tažení středu je posun, CTRL + tažení středu mění průměr\n" +
  "projektovaný bod vytvořený pomocí kontextového menu: tažení bodu tento posune, CTRL + tažení bodu posune oba body\n" +
  "pravý klik na waypoint: další menu...\n" +
  "... mnoho, mnoho, mnoho dalších kombinací kláves v menu Track, které má vlastní nápovědu\n" +
  "... a pokud si otevřete minimapu, na pravém tlačítku tam máte další nápovědu\n" +
  "\nv" + macro_version + ", " + cur_date + ", by Norbert_G"
}

// create context menu html
var contextMenuUl = "" +
  "<ul class=\"context_menu\" id=\"contextMenu\" style=\"display: none\">\n" +
  "  <li id=\"cm_center_map_here\">" + tr("Center Map Here") + "</li>\n" +
  "  <li id=\"cm_show_all\">" + tr("Show All") + "</li>\n" +
  "  <li id=\"cm_add_child_here\" class=GSAK_Only>" + tr("Add Child Here") + "</li>\n" +
  "  <li id=\"cm_add_waypoint_here\" class=GSAK_Only>" + tr("Add Waypoint Here") + "</li>\n" +
  "  <li id=\"cm_coordinates_to_clipboard\" class=GSAK_Only>" + tr("Coordinates to Clipboard") + "</li>\n" +
  "  <li id=\"cm_set_gsak_center_point\" class=GSAK_Only>" + tr("Set GSAK Center Point") + "</li>\n" +
  "  <li id=\"cm_project_point\">" + tr("Project point...") + "</li>\n" +
  "  <li id=\"cm_draw_circle\">" + tr("Draw a circle...") + "</li>\n" +
  "  <li id=\"cm_run_map_macro\" class=GSAK_Only>" + tr("Run Map Macro") + "</li>\n" +
  "  <li id=\"cm_geolocation_ws\">" + tr("_open_photo_page") + " (<span id=\"cm_open_google\">Google</span>, <span id=\"cm_open_mapycz\">Mapy.cz</span>)</li>\n" +
  "  <li id=\"cm_turistikacz\">Turistika.cz (<span id=\"cm_amapycz\">aMapy.cz</span>, <span id=\"cm_geocaching_com\">GC.com</span>, <span id=\"cm_land_registry\">" + tr("Land Registry (CZ)") + "</span>)</li>\n" +
  "  <li id=\"cm_street_view\">Street View v3 <span id=\"cm_street_view_v2\">(v2)</span></li>  \n" +
  "  <li id=\"cm_help\">" + tr("Help") + "</li>\n" +
  "  <li id=\"cm_find_form\"><span>" + tr("Find: ") + "</span><form id=\"findForm\"><input id=\"findBox\" type=\"text\"></form></li>\n" +
  "</ul>";                                                                        
  
var contextMenuWPUl = "" +  
  "<ul class=\"context_menu\" id=\"contextMenuWP\" style=\"display: none\">\n" +
  "  <li id=\"cmwp_save_new_coordinates\" class=GSAK_Only>" + tr("Save New Coordinates") + "</li>\n" +
  "  <li id=\"cmwp_flag_parent\" class=GSAK_Only>" + tr("Flag (Parent)") + "</li>\n" +
  "  <li id=\"cmwp_remove_flag_parent\" class=GSAK_Only>" + tr("Remove Flag (Parent)") + "</li>\n" +
  "  <li id=\"cmwp_flag_child\" class=GSAK_Only>" + tr("Flag (Child)") + "</li>\n" +
  "  <li id=\"cmwp_remove_flag_child\" class=GSAK_Only>" + tr("Remove Flag (Child)") + "</li>\n" +
  "  <li id=\"cmwp_delete_parent\" class=GSAK_Only>" + tr("Delete (Parent)") + "</li>\n" +
  "  <li id=\"cmwp_delete_child\" class=GSAK_Only>" + tr("Delete (Child)") + "</li>\n" +
  "  <li id=\"cmwp_remove_from_map\">" + tr("Remove from Map") + "</li>\n" +
  "  <li id=\"cmwp_open_waypoint_page\">" + tr("Open Waypoint Page") + "</li>\n" +
  "  <li id=\"cmwp_open_cache_page\">" + tr("Open Cache Page") + "</li>\n" +
  "  <li id=\"cmwp_open_waymark_page\">" + tr("Open Waymark Page") + "</li>\n" +
  "  <li id=\"cmwp_open_in_gsak\" class=GSAK_Only>" + tr("Open in GSAK") + "</li>\n" +  
  "  <li id=\"cmwp_open_cache_gallery\">" + tr("Open Cache Gallery") + "</li>\n" +
  "  <li id=\"cmwp_open_cache_logbook\">" + tr("Open Cache Logbook") + "</li>\n" +
  "  <li id=\"cmwp_log_cache\">" + tr("Log Cache") + "</li>\n" +
  "  <li id=\"cmwp_log_waymark\">" + tr("Log Waymark") + "</li>\n" +
  "  <li id=\"cmwp_project_point\">" + tr("Project point...") + "</li>\n" +
  "  <li id=\"cmwp_draw_circle\">" + tr("Draw a circle...") + "</li>\n" +  
  "</ul>";
  
var ctDiv = document.createElement("div");
ctDiv.innerHTML = contextMenuUl + contextMenuWPUl;

mapadiv.parentNode.insertBefore(ctDiv.lastChild, mapadiv.nextSibling);
mapadiv.parentNode.insertBefore(ctDiv.lastChild, mapadiv.nextSibling);


//translate_strings();

//alert("loading");

//********************************************
// context menu functions
//********************************************

var contextMenu =
{
  init: window.setTimeout(function()
  {
    EventUtil.addHandler(document.documentElement, 'click', function click(e, target)
    {
      contextMenu.hideAllContextMenus();
      window.contextMenuActive = false;    
    });
  }, 0),

  hideAllContextMenus: function()
  {
    for (var i in contextMenu.menuList)
      contextMenu.menuList[i].menu.style.display = "none";
  },
  
  addContextMenu: function(element, menu, rightClickCustomFunction, leftClickCustomFunction, options)
  {
    // if context menu is already attached to the element, then exit
    for (var i in contextMenu.menuList)
    {
      if (contextMenu.menuList[i].element === element)
        return 0;
    }    

    options = options || {};
    options.menuIndex = ++contextMenu.menuSettings.max;

    var handlerRightClick = EventUtil.addHandler(element, 'contextmenu', function (e, target)
    {
      if (e.shiftKey || e.ctrlKey || e.altKey)
        return;
    
      EventUtil.preventDefault(e);
      EventUtil.stopPropagation(e);
      contextMenu.hideAllContextMenus();
      menu.style.display = "block";
    
      // are there any pixels outside of the viewport?
      // http://www.quirksmode.org/mobile/viewports.html
      var offset_right  = document.documentElement.clientWidth - (e.clientX + menu.offsetWidth);
      var offset_bottom = document.documentElement.clientHeight - (e.clientY + menu.offsetHeight);
      
      // position menu on the screen so that no part is hidden (if it is too right/low)
      menu.style.top = Math.max(0, (e.clientY - ((offset_bottom < 0) ? menu.offsetHeight : 0))) + "px";
      menu.style.left = Math.max(0, (e.clientX - ((offset_right < 0) ? menu.offsetWidth : 0))) + "px";

      // save last clicked menu index
      contextMenu.menuSettings.last = options.menuIndex;
      
      // save global variable (so that we can test whether any menu is active)
      window.contextMenuActive = true;

      // run custom function
      rightClickCustomFunction(e, target, menu, options);
    });

    var handlerLeftClick = EventUtil.addHandler(menu, 'click', function (e, target)
    {
      // if there are more listeners attached to one menu, choose the correct one
      if (options.menuIndex != contextMenu.menuSettings.last)
        return;
      
      // IE7 treats comments as tags, so switch to parent  
      if (target.tagName === "!")
        target = target.parentNode;
        
      // if returned false or nothing, then hide the menu
      if (!leftClickCustomFunction(e, target, menu, options))
        menu.style.display = 'none';
      else
        EventUtil.stopPropagation(e);
    });
    
    contextMenu.menuList[contextMenu.menuSettings.max] = {handlerRightClick: handlerRightClick, handlerLeftClick: handlerLeftClick, menu: menu, element: element, options: options};
    return contextMenu.menuSettings.max;
  },
  
  removeContextMenu: function(index)
  {
    if (!index || typeof contextMenu.menuList[index] === 'undefined')
      return;

    EventUtil.removeHandler(contextMenu.menuList[index].handlerRightClick);
    EventUtil.removeHandler(contextMenu.menuList[index].handlerLeftClick);
    delete contextMenu.menuList[index];
  },
  
  // max: last added menu index, last: last activated menu index
  menuList: {},
  menuSettings: {max: 0, last: 0}
}

//********************************************
// map context menu
//********************************************

contextMenu.addContextMenu(mapAreaDiv, document.getElementById('contextMenu'), 
function (e, target, menu, options)
{
  // remove keypress propagation
  var menu = document.getElementById('contextMenu');
  EventUtil.addHandler(menu, "keydown", function(e) {EventUtil.stopPropagation(e);});
  EventUtil.addHandler(menu, "keyup", function(e) {EventUtil.stopPropagation(e);});
  EventUtil.addHandler(menu, "keypress", function(e) {EventUtil.stopPropagation(e);});
  
  menu.lastCoords = new SMap.Coords.fromEvent(e, m); 
},

function (e, target, menu, options) 
{
  // retrieve lat/lon
  var coords = menu.lastCoords;       
  var latlon = coords.toWGS84("LatLon");
  var lat = latlon[0];
  var lon = latlon[1];

  if (target.id == "cm_zoom_here")
  ;
        
  else if (target.id == "cm_center_map_here")
    m.setCenter(coords);
  
  else if (target.id == "cm_show_all")
    m.setCenterZoom.apply(m, m.computeCenterZoom(souradnice));

  else if (target.id == "cm_add_child_here")
    window.location.href = "gsak://%FF/Addchild/" + lat + "/" + lon + "/" + cachecode;

  else if (target.id == "cm_add_waypoint_here")
    window.location.href = "gsak://%FF/AddWpt/" + lat + "/" + lon;
     
  else if (target.id == "cm_coordinates_to_clipboard")
    window.location.href = "gsak://%FF/ClipBoard/" + lat + " " + lon;

  else if (target.id == "cm_set_gsak_center_point")
    window.location.href = "gsak://%FF/Center/" + lat + "/" + lon;

  else if (target.id == "cm_run_map_macro")
    window.location.href = "gsak://%FF/MapMacro/" + lat + "/" + lon;

  else if (target.id == "cm_geolocation_ws" || target.id == "cm_open_google" || target.id == "cm_open_mapycz"
    || target.id == "cm_turistikacz" || target.id == "cm_amapycz" || target.id == "cm_geocaching_com" || target.id == "cm_land_registry")
  {
    var zoom = m.getZoom() + (m.isUTM33() ? 2 : 0);
    
    if (target.id == "cm_geolocation_ws")
      window.open("http://www.geolocation.ws/map/" + lat + "," + lon + "/" + Math.min(zoom, 18) + "/en");
    
    else if (target.id == "cm_open_google")
      window.open("http://maps.google.com/maps?ll=" + lat + "," + lon + "&z=" + zoom + "&lci=com.panoramio.all");
      
    else if (target.id == "cm_open_mapycz")
      window.open("http://mapy.cz/#x=" + lon + "&y=" + lat + "&z=" + (zoom - 2) + "&l=15&c=f-t-c");
    
    else if (target.id == "cm_turistikacz")
      window.open("http://www.turistika.cz/mapy/volny-cas?s_lat=" + lat + "&s_lng=" + lon);
      
    else if (target.id == "cm_amapycz")
      window.open("http://amapy.centrum.cz/objekty-poi-m25?c=" + lat + "," + lon + "&z=" + zoom + "&mc=h");
      
    else if (target.id == "cm_geocaching_com")
      window.open("http://www.geocaching.com/map/?ll=" + lat + "," + lon);

    else if (target.id == "cm_land_registry")
    {
      var sjtsk = coords.toSJTSK();
      window.open('http://nahlizenidokn.cuzk.cz/MapaIdentifikace.aspx?&x=' + Math.round(sjtsk[0]) + '&y=' + Math.round(sjtsk[1]));
    }
  }  
  
  else if (target.id == "cm_street_view" || target.id == "cm_street_view_v2")
  {
    if (typeof StreetViewDiv === 'undefined')
    {
      window.startStreetViewCoords = coords;
      loadCSS(basePath + "streetview.css");
      loadJS(basePath + "streetview" + ((target.id == "cm_street_view") ? 3 : 2) + ".js");
      
      // remove option to choose version
      document.getElementById("cm_street_view").innerHTML = "Street View";
    }
    else
    {
      reloadStreetView(coords);
    }
  }  
  
  else if (target.id == "cm_find_form" || EventUtil.isSubnode(target, document.getElementById("cm_find_form")))
  {
    var form = document.getElementById("findForm");

    // function, that executes online search
    window.findExecute = function ()
    {
      var place = form.elements["findBox"].value;
      
      if (place)
        LocationLookup(place, lat, lon);
    }

    // initialize listeners
    if (!form.getAttribute("initialized"))
    {
      form.setAttribute("initialized", true);

      // prevent automatic submit (handle ENTER manually instead - automatic submit doesn't work in IE)
      EventUtil.addHandler(form, 'submit', function (e, target)
      {
        EventUtil.preventDefault(e);
      });

      // on ENTER execute search
      EventUtil.addHandler(form.elements["findBox"], 'keydown', function (e, target)
      {
        if (e.keyCode == 13)
        {
          window.findExecute();
          EventUtil.preventDefault(e);
          menu.style.display = "none";
        }
      });
    }

    // execute search on clicking label, return (without closing menu) otherwise
    if (target.tagName.toLowerCase() == "span")
      window.findExecute();
    else
      return true;
  }
  
  else if (target.id == "cm_help")
    ui("copybox", {text: tr("about_box"), width: 600, height: 300});
    
  // project point
  else if (target.id == "cm_project_point")
    drawcircle_projectpoint("projectPointOnMap", coords);

  // draw a circle
  else if (target.id == "cm_draw_circle")
    drawcircle_projectpoint("createCircleOnMap", coords);

    //alert(tr("about_box"));
});  

//********************************************
// marker context menu
//********************************************

function markerContextMenu(element, code, parent){
  var handlerContextMenu = contextMenu.addContextMenu(element, document.getElementById('contextMenuWP'), 
  function (e, target, menu, options)
  {
    var Code = options.code;
    var parent = options.parent;
    
    // show "Save New Coordinates" only if the point has been dragged + when it's not CC
    document.querySelector("#cmwp_save_new_coordinates").style.display = (wp[Code].dragged && wp[Code].CacheType != "Corrected") ? "block" : "none";
    
    // show/hide add/remove flags items
    document.querySelector("#cmwp_flag_parent").style.display = (!wp[parent].UserFlag) ? "block" : "none";
    document.querySelector("#cmwp_remove_flag_parent").style.display = (wp[parent].UserFlag) ? "block" : "none";
    document.querySelector("#cmwp_flag_child").style.display = (Code !== parent && !wp[Code].UserFlag && wp[Code].CacheType != "Corrected") ? "block" : "none";
    document.querySelector("#cmwp_remove_flag_child").style.display = (Code !== parent && wp[Code].UserFlag && wp[Code].CacheType != "Corrected") ? "block" : "none";

    // hide all links that open cache/waymark/waypoint URL (then enable them selectively)
    document.querySelector("#cmwp_open_waypoint_page").style.display = "none";
    document.querySelector("#cmwp_open_cache_page").style.display = "none";
    document.querySelector("#cmwp_open_waymark_page").style.display = "none";
    document.querySelector("#cmwp_open_cache_gallery").style.display = "none";
    document.querySelector("#cmwp_open_cache_logbook").style.display = "none";
    document.querySelector("#cmwp_log_cache").style.display = "none";
    document.querySelector("#cmwp_log_waymark").style.display = "none";
    
    // add Guid, if not exists
    if (/^(GC|WM)/.test(parent) && !wp[parent].Guid && wp[parent].Url && /guid=(.{36})/.test(wp[parent].Url))
    {
      wp[parent].Guid = wp[parent].Url.match(/guid=(.{36})/)[1];
    }
    
    // add CacheId, if not exists
    if (!wp[parent].CacheId && /^GC([0-9A-HJ-KM-NP-RTV-Z]+)$/.test(parent))
    {
      var idHex = parent.match(/^(GC|WM)(.*)/)[2];
      
      // 0-FFFF
      if (/^[0-9A-F]{1,4}$/.test(idHex))
        wp[parent].CacheId = parseInt(idHex, 16);
      
      // > FFFF
      else
      {
        var WPTCHARS = "0123456789ABCDEFGHJKMNPQRTVWXYZ";
        var accum = 0;
  
        for (var i = 0; i < idHex.length; i++)
          accum = accum * 31 + WPTCHARS.indexOf(idHex[i]);

        wp[parent].CacheId = Math.abs(accum - 16 * 31 * 31 * 31 + 65536);
      } 
    }
        
    if (/^GC/.test(parent))
    {
      document.querySelector("#cmwp_open_cache_page").style.display = "block";  
    
      if (wp[parent].CacheId)
      {
        document.querySelector("#cmwp_open_cache_gallery").style.display = "block";
        document.querySelector("#cmwp_log_cache").style.display = "block";
      }
      if (wp[parent].Guid)
      {
        document.querySelector("#cmwp_open_cache_logbook").style.display = "block";
      }          
    }
    
    else if (/^WM/.test(parent))
    {
      document.querySelector("#cmwp_open_waymark_page").style.display = "block";
    
      if (wp[parent].Guid)
        document.querySelector("#cmwp_log_waymark").style.display = "block";
    }
    
    else if (wp[Code].Url || wp[parent].Url)
    {
      document.querySelector("#cmwp_open_waypoint_page").style.display = "block"
    }

    // flag first/last item (for CSS round borders)
    var first = document.querySelector("#contextMenuWP .cm_first");
    
    if (first)
      remove_class(first, "cm_first");
    
    for (var i = 0, len = menu.childNodes.length; i < len; i++)
    {
      var li = menu.childNodes[i];
      
      if ((li.style && li.style.display != "none") && (!contains_class(li, "GSAK_Only") || !window.notGSAK))
      {
        add_class(li, "cm_first");
        break;
      }
    }
    
    // last
    var last = document.querySelector("#contextMenuWP .cm_last");
    
    if (last)
      remove_class(first, "cm_last");
    
    for (var i = menu.childNodes.length - 1; i >= 0; i--)
    {
      var li = menu.childNodes[i];
      
      if ((li.style && li.style.display != "none") && (!contains_class(li, "GSAK_Only") || !window.notGSAK))
      {
        add_class(li, "cm_last");
        break;
      }
    }    
  
    // show/hide delete child item
    document.querySelector("#cmwp_delete_child").style.display = (Code !== parent && wp[Code].CacheType != "Corrected") ? "block" : "none";
  },
  
  function (e, target, menu, options)
  {
    var Code = options.code;
    var parent = options.parent;

    var lat = wp[Code].Latitude;
    var lon = wp[Code].Longitude;
    var coords = SMap.Coords.fromWGS84(lon, lat);
    
    if (target.id == "cmwp_save_new_coordinates")
    {
      if (confirm(tr("wp_drag_ask")))
      {
        var new_lat = wp[Code].dragged[0];
        var new_lon = wp[Code].dragged[1];
        window.location.href = "gsak://%FF/macro:silent/HTML_Custom_MapyCZ\\Update_Database.gsk?" + "move_marker" + "###" + Code + "###" + + new_lat + "###" + new_lon + "/" + parent;
        
        wp[Code].Latitude = new_lat;
        wp[Code].Longitude = new_lon;
        delete wp[Code].dragged;
      }
    }
    
    else if (target.id == "cmwp_flag_parent")
    {
      window.location.href = "gsak://%FF/flagset:silent/" + parent;
      wp[Code].UserFlag = 1; 
    }
    
    else if (target.id == "cmwp_remove_flag_parent")
    {
      window.location.href = "gsak://%FF/flagclear:silent/" + parent;
      wp[Code].UserFlag = 0; 
    }
    
    else if (target.id == "cmwp_flag_child")
    {
      window.location.href = "gsak://%FF/macro:silent/HTML_Custom_MapyCZ\\Update_Database.gsk?" + "flag_child" + "###" + Code + "/" + parent;
      wp[Code].UserFlag = 1; 
    }
    
    else if (target.id == "cmwp_remove_flag_child")
    {
      window.location.href = "gsak://%FF/macro:silent/HTML_Custom_MapyCZ\\Update_Database.gsk?" + "remove_flag_child" + "###" + Code + "/" + parent;
      wp[Code].UserFlag = 0; 
    }

    else if (target.id == "cmwp_delete_parent")
    {
      if (confirm(tr("wp_delete_parent")))
      {
        window.location.href = "gsak://%FF/macro:silent/HTML_Custom_MapyCZ\\Update_Database.gsk?" + "delete_parent" + "###" + parent + "/" + parent;
        delete_waypoint(get_all_in_family(Code));
      }
    }
    
    else if (target.id == "cmwp_delete_child")
    {
      if (confirm(tr("wp_delete_child")))
      {
        window.location.href = "gsak://%FF/macro:silent/HTML_Custom_MapyCZ\\Update_Database.gsk?" + "delete_child" + "###" + Code + "/" + parent;
        delete_waypoint(Code);
      }
    }
    
    else if (target.id == "cmwp_remove_from_map")
    {
      delete_waypoint((Code == parent || wp[Code].CacheType == "Corrected") ? get_all_in_family(parent) : Code);
    }
    
    else if (target.id == "cmwp_open_waypoint_page")
    {
      window.open(wp[Code].Url || wp[parent].Url);
    }

    else if (target.id == "cmwp_open_cache_page" || target.id == "cmwp_open_waymark_page")
    {
      window.open("http://coord.info/" + parent);
    }
    
    else if (target.id == "cmwp_open_in_gsak")
    {
      location.href = "gsak://%FF/Search/" + parent;
    }    
    
    else if (target.id == "cmwp_open_cache_gallery")
    {
      window.open("http://www.geocaching.com/seek/gallery.aspx?id=" + wp[parent].CacheId);
    }    

    else if (target.id == "cmwp_open_cache_logbook")
    {
      window.open("http://www.geocaching.com/seek/cache_logbook.aspx?guid=" + wp[parent].Guid);
    }

    else if (target.id == "cmwp_log_cache")
    {
      window.open("http://www.geocaching.com/seek/log.aspx?id=" + wp[parent].CacheId);
    }

    else if (target.id == "cmwp_log_waymark")
    {
      window.open("http://www.waymarking.com/logs/add.aspx?f=1&guid=" + wp[parent].Guid + "&logtype=1");
    }
    
    // draw a circle
    else if (target.id == "cmwp_draw_circle")
    {
      drawcircle_projectpoint("createCircleOnMap", coords);
    }
    
    // project point
    else if (target.id == "cmwp_project_point")
    {
      drawcircle_projectpoint("projectPointOnMap", coords);
    }    
  
    // delete all listeners to current menu
    for (var i in contextMenu.menuList)
    {
      if (contextMenu.menuList[i].menu === menu)
        contextMenu.removeContextMenu(i);
    }
  },
  
  {code: code, parent: parent}
  );

  return handlerContextMenu;  
};

//************************
// load draw circle / project point functions
function drawcircle_projectpoint(fnName, coords)
{
  if (typeof projectPointOnMap === 'undefined')
  {
    loadCSS(basePath + "drawcircle_projectpoint.css");
    loadJS(basePath + "drawcircle_projectpoint.js", function(){window[fnName](coords)});
  }
  else
    window[fnName](coords);
}

// **** fix edit boxes
fixEditBoxesInIE();